window.addEventListener('DOMContentLoaded', load, false);

function load() {
	//form
	var form_id = document.getElementById('form');
	var url_id = document.getElementById('url');
	var xpath_id = document.getElementById('xpath');
	var hide_images_id = document.getElementById('hide_images');
	var show_url_content_id = document.getElementById('show_url_content');
	var url_content_id = document.getElementById('url_content');

	var httpRequest;

	show_url_content_id.addEventListener('click', get_content, false);

	get_content();

	function get_content() {
		var url = url_id.value;
		var xpath = xpath_id.value;

		var url_yahoo_root = 'http://query.yahooapis.com/v1/public/yql?q=';
		var url_yahoo_params = '';

		var query = encodeURIComponent('select * from html where url="' + url + '" and xpath=\'' + xpath + '\' and compat="html5"');
		var url_request = url_yahoo_root + query + url_yahoo_params;

		httpRequest = new XMLHttpRequest();
		httpRequest.onreadystatechange = function() {
			if (httpRequest.readyState === 4) {
				if (httpRequest.status === 200) {
					var response = httpRequest.responseText;

					var response_doc = document.implementation.createHTMLDocument("url_content_dom");
					response_doc.documentElement.innerHTML = response;

					var results = response_doc.getElementsByTagName('results')[0];
					
					results = get_clean_html(results, 'script');
					results = get_clean_html(results, 'iframe');
					results = get_formatted_links(results, 'a');
					results = get_formatted_links(results, 'img');

					if (hide_images_id.checked) {
						results = get_clean_html(results, 'img');
					}
					//insert content
					url_content_id.innerHTML = results.innerHTML;
				} else {
					var response = 'There was a problem with the request.';
					url_content_id.innerHTML = response;
				}
			}
		};
		httpRequest.open("GET", url_request, true);
		httpRequest.send(null);

		function get_clean_html(html_results, tag_name) {
			try {
				var element = html_results.getElementsByTagName(tag_name);
				for (index = element.length - 1; index >= 0; index--) {
					element[index].parentNode.removeChild(element[index]);
				}
			} catch (err) {
				console.log('not found tag ' + tag_name + '. Error: ' + err);
			}
			return html_results;
		}

		function get_formatted_links(html_results, tag_name) {
			try {
				var element = html_results.getElementsByTagName(tag_name);
				if (tag_name == 'a') {
					var attr = 'href';
				} else {
					var attr = 'src'
				}
				for (index = element.length - 1; index >= 0; index--) {
					var link = element[index].getAttribute(attr);
					if (link != null && link.substring(0, 7) != "http://" && link.substring(0, 8) != "https://") {
						element[index].setAttribute("href", url + link);
					};
				}
			} catch (err) {
				console.log('not found tag ' + tag_name + '. Error: ' + err);
			}
			return html_results;
		}
	}

}